<div class="container">
  <div class="row">
    <div class="col-xs-12 col-sm-10 col-md-8 col-sm-offset-1 col-md-offset-2">
      <form [formGroup]="signupForm" (ngSubmit)="onSubmit()">
        <div formGroupName="userData">
          <div class="form-group">
          <label for="username">Username</label>
          <input
            type="text"
            id="username"
            formControlName="username"
            class="form-control">
            <span class="help-block" 
            *ngIf="!signupForm.get('userData.username').valid && 
                    signupForm.get('userData.username').touched">
              <span *ngIf="signupForm.get('userData.username').errors['forbidden']">
                        Username is forbidden</span>
              <span *ngIf="signupForm.get('userData.username').errors['required']">
                  PLease enter valid username</span>
            </span>
        </div>
        <div class="form-group">
          <label for="email">email</label>
          <input
            type="text"
            id="email"
            formControlName="email"
            class="form-control">
        </div>
        </div>
        <div formArrayName="hobbies">
          <h4>Add your Hobby</h4>
          <button class="btn btn-default" type="button" (click)="onAddHobby()">Add Hobby</button>
          <div class="form-group" *ngFor="let hobby of signupForm.get('hobbies').controls; let i= index">
            <input type="text" class="form-control" [formControlName]="i">
          </div>
        </div>
        <div class="radio" *ngFor="let gender of genders">
          <label>
            <input
              formControlName="gender"
              type="radio"
              [value]="gender">{{ gender }}
          </label>
        </div>
        <button class="btn btn-primary" type="submit" [disabled]="!signupForm.valid">Submit</button>
      </form>
    </div>
  </div>
</div>